#version 120
uniform float time;
uniform sampler2D texture;

float length2(vec2 p) { return dot(p, p); }

float noise(vec2 p){
	return fract(sin(fract(sin(p.x) * (41.13311)) + p.y) * 31.0011);
}

float worley(vec2 p) {
	float d = 1e30;
	for (int xo = -1; xo <= 1; ++xo) {
		for (int yo = -1; yo <= 1; ++yo) {
			vec2 tp = floor(p) + vec2(xo, yo);
			d = min(d, length2(p - tp - vec2(noise(tp))));
		}
	}
	return 0.01*exp(-1.1*abs(3 * d - 6.0));
}

float fworley(vec2 p) {
	return sqrt(sqrt(sqrt(
		3.8 * // light
                worley(p*100.0 + 3.5 + time * 1.1525) *
                sqrt(worley(p * 20.0 + 1 + time * -3.5))
		)));
}

void main() {
	vec3 Tint = vec3(4, 0, 20);
	float ratio = 5;
	float sizeMultiply = 0.61;
	vec4 tex = texture2D(texture, gl_TexCoord[0].xy);
	vec2 uv = vec2(gl_TexCoord[0].x * ratio, gl_TexCoord[0].y) * sizeMultiply;
	float t = fworley(uv * 0.02);
	t *= exp(-length2(abs(0.7*uv - 1.0)));
	float oneVal = (0.1 + 1.5*t + 1.2*t + pow(t, 0.5-t)) / 3;
	vec4 val = vec4(tex.rgb * Tint, 1.0) * vec4(t * vec3(0.9, 1.1*t, 1.2*t + pow(t, 1-t)), 1.0);
	gl_FragColor = val;
}